/**********************************************/
/* OCŃhSXC[ϊvO */
/*               PC-8801 -> PC-6001mk2        */
/**********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	S_LEN	255
#define	BUFNUM	16000

int main(int argc, char **argv)
{
	FILE	*iplfp;
	FILE	*pr0fp,*pr1fp,*p_bfp,*p_grfp;
	FILE	*p6_1fp,*p6_2fp;
	FILE	*map01fp,*map02fp,*map03fp,*map04fp,*map05fp;
	FILE	*map06fp,*map07fp,*map08fp,*map09fp,*map10fp;
	FILE	*map11fp,*map12fp,*map13fp,*map14fp,*map15fp;
	FILE	*map16fp,*map17fp,*map18fp,*map19fp,*map20fp;
	FILE	*outfp;
	int		i,j,k,m,z;
	int		ds,trackpt;

	if (argc != 1) {
		fprintf(stderr, "Usage: gen_dragonp6\n");
		exit(1);
	}

	if ((iplfp = fopen("ipl.bin", "rb")) == NULL) {
		perror("ipl.bin");
		exit(1);
	}

	if ((pr0fp = fopen("pr0.bin", "rb")) == NULL) {
		perror("pr0.bin");
		exit(1);
	}

	if ((pr1fp = fopen("pr1.bin", "rb")) == NULL) {
		perror("pr1.bin");
		exit(1);
	}

	if ((p_bfp = fopen("p_b.bin", "rb")) == NULL) {
		perror("p_b.bin");
		exit(1);
	}

	if ((p_grfp = fopen("p_gr.bin", "rb")) == NULL) {
		perror("p_gr.bin");
		exit(1);
	}

	if ((p6_1fp = fopen("prog_p6_1.bin", "rb")) == NULL) {
		perror("prog_p6_1.bin");
		exit(1);
	}

	if ((p6_2fp = fopen("prog_p6_2.bin", "rb")) == NULL) {
		perror("prog_p6_2.bin");
		exit(1);
	}

	if ((map01fp = fopen("map01.bin", "rb")) == NULL) {
		perror("map01.bin");
		exit(1);
	}

	if ((map02fp = fopen("map02.bin", "rb")) == NULL) {
		perror("map02.bin");
		exit(1);
	}

	if ((map03fp = fopen("map03.bin", "rb")) == NULL) {
		perror("map03.bin");
		exit(1);
	}

	if ((map04fp = fopen("map04.bin", "rb")) == NULL) {
		perror("map04.bin");
		exit(1);
	}

	if ((map05fp = fopen("map05.bin", "rb")) == NULL) {
		perror("map05.bin");
		exit(1);
	}

	if ((map06fp = fopen("map06.bin", "rb")) == NULL) {
		perror("map06.bin");
		exit(1);
	}

	if ((map07fp = fopen("map07.bin", "rb")) == NULL) {
		perror("map07.bin");
		exit(1);
	}

	if ((map08fp = fopen("map08.bin", "rb")) == NULL) {
		perror("map08.bin");
		exit(1);
	}

	if ((map09fp = fopen("map09.bin", "rb")) == NULL) {
		perror("map09.bin");
		exit(1);
	}

	if ((map10fp = fopen("map10.bin", "rb")) == NULL) {
		perror("map10.bin");
		exit(1);
	}

	if ((map11fp = fopen("map11.bin", "rb")) == NULL) {
		perror("map11.bin");
		exit(1);
	}

	if ((map12fp = fopen("map12.bin", "rb")) == NULL) {
		perror("map12.bin");
		exit(1);
	}

	if ((map13fp = fopen("map13.bin", "rb")) == NULL) {
		perror("map13.bin");
		exit(1);
	}

	if ((map14fp = fopen("map14.bin", "rb")) == NULL) {
		perror("map14.bin");
		exit(1);
	}

	if ((map15fp = fopen("map15.bin", "rb")) == NULL) {
		perror("map15.bin");
		exit(1);
	}

	if ((map16fp = fopen("map16.bin", "rb")) == NULL) {
		perror("map16.bin");
		exit(1);
	}

	if ((map17fp = fopen("map17.bin", "rb")) == NULL) {
		perror("map17.bin");
		exit(1);
	}

	if ((map18fp = fopen("map18.bin", "rb")) == NULL) {
		perror("map18.bin");
		exit(1);
	}

	if ((map19fp = fopen("map19.bin", "rb")) == NULL) {
		perror("map19.bin");
		exit(1);
	}

	if ((map20fp = fopen("map20.bin", "rb")) == NULL) {
		perror("map20.bin");
		exit(1);
	}

	if ((outfp = fopen("dragonp6.d88", "wb")) == NULL) {
		perror("dragonp6.d88");
		exit(1);
	}

/* header */

	fputs("dragonp6",outfp);
	for (i=0; i<20; i ++) {
		fputc(0,outfp);
	}

/* disk size (4 bytes) */

/* header 0x2b0 */
/* track#0x00-0x27 (0x10+0x100) * 0x10 */

	ds = 0x2b0 + 0x10 * 0x110 * 40;

	fputc(  (ds & 0x000000ff)      ,outfp);
	fputc( ((ds & 0x0000ff00)>> 8) ,outfp);
	fputc( ((ds & 0x00ff0000)>>16) ,outfp);
	fputc( ((ds & 0xff000000)>>24) ,outfp);

/* track data table (164 * 4 bytes) */

	trackpt = 0x2b0;

	for (i=0; i<80; i+=2) {
		fputc(  (trackpt & 0x000000ff)      ,outfp);
		fputc( ((trackpt & 0x0000ff00)>> 8) ,outfp);
		fputc( ((trackpt & 0x00ff0000)>>16) ,outfp);
		fputc( ((trackpt & 0xff000000)>>24) ,outfp);
		fputc(0,outfp);
		fputc(0,outfp);
		fputc(0,outfp);
		fputc(0,outfp);
		trackpt += (0x10 * 0x110);
	}

	for (; i<164; i++) {
		fputc(0,outfp);
		fputc(0,outfp);
		fputc(0,outfp);
		fputc(0,outfp);
	}

	for (k=0; k<40; k ++) {

/* header */
		for (i=0; i<16; i++) {
			fputc(k,outfp);		// C
			fputc(0,outfp);		// H
			fputc(i+1,outfp);	// R
			fputc(1,outfp);		// N
			fputc(16,outfp);	// sector number
			fputc(0,outfp);		// sector number
			fputc(0,outfp);		// MFM
			fputc(0,outfp);		// normal data
			fputc(0,outfp);		// status normal
			fputc(0,outfp);		// reserved
			fputc(0,outfp);		// reserved
			fputc(0,outfp);		// reserved
			fputc(0,outfp);		// reserved
			fputc(0,outfp);		// reserved
			fputc(0,outfp);		// sector size
			fputc(1,outfp);		// sector size


			switch (k) {
				case  0:
/* track#0 sector#1 -> IPL */
					for (j=0; j<256; j++ ) {
						if (i == 0) {
							fputc(fgetc(iplfp),outfp);
						} else {
							fputc(0x00,outfp);
						}
					}
					break;

				case  3:
				case  4:
				case  5:
/* track#3 -> pr0 */
/* track#4,5 -> pr1 */
					for (j=0; j<256; j++ ) {
						m = (k-3)*4096 + i*256 + j;
						switch (m) {

/* ̃vOɃpb`𓖂Ă */
							case 0x0138: fputc(0x9c,outfp); z=fgetc(pr0fp); break;
							case 0x0139: fputc(0x08,outfp); z=fgetc(pr0fp); break;
							case 0x02ad: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x02ae: fputc(0x0f,outfp); z=fgetc(pr0fp); break;
							case 0x02af: fputc(0xe0,outfp); z=fgetc(pr0fp); break;
							case 0x04b4: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x04b5: fputc(0x33,outfp); z=fgetc(pr0fp); break;
							case 0x04b6: fputc(0xe0,outfp); z=fgetc(pr0fp); break;
							case 0x0581: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x0582: fputc(0x03,outfp); z=fgetc(pr0fp); break;
							case 0x0583: fputc(0x70,outfp); z=fgetc(pr0fp); break;
							case 0x0610: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x0611: fputc(0x2a,outfp); z=fgetc(pr0fp); break;
							case 0x0612: fputc(0xe0,outfp); z=fgetc(pr0fp); break;
							case 0x0669: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x066a: fputc(0x09,outfp); z=fgetc(pr0fp); break;
							case 0x066b: fputc(0x70,outfp); z=fgetc(pr0fp); break;
							case 0x06ca: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x06cb: fputc(0x0f,outfp); z=fgetc(pr0fp); break;
							case 0x06cc: fputc(0x70,outfp); z=fgetc(pr0fp); break;
							case 0x0715: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x0716: fputc(0x12,outfp); z=fgetc(pr0fp); break;
							case 0x0717: fputc(0x70,outfp); z=fgetc(pr0fp); break;
							case 0x0762: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x0763: fputc(0x0c,outfp); z=fgetc(pr0fp); break;
							case 0x0764: fputc(0x70,outfp); z=fgetc(pr0fp); break;
							case 0x07a2: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x07a3: fputc(0x06,outfp); z=fgetc(pr0fp); break;
							case 0x07a4: fputc(0x70,outfp); z=fgetc(pr0fp); break;
							case 0x0945: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x0946: fputc(0x27,outfp); z=fgetc(pr0fp); break;
							case 0x0947: fputc(0xe0,outfp); z=fgetc(pr0fp); break;
							case 0x0c93: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x0c94: fputc(0x2d,outfp); z=fgetc(pr0fp); break;
							case 0x0c95: fputc(0xe0,outfp); z=fgetc(pr0fp); break;
							case 0x0cfb: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x0cfc: fputc(0x00,outfp); z=fgetc(pr0fp); break;
							case 0x0cfd: fputc(0x70,outfp); z=fgetc(pr0fp); break;
							case 0x0ebb: fputc(0x00,outfp); z=fgetc(pr0fp); break;
							case 0x0ebc: fputc(0xcd,outfp); z=fgetc(pr0fp); break;
							case 0x0ebd: fputc(0x12,outfp); z=fgetc(pr0fp); break;
							case 0x0ebe: fputc(0xe0,outfp); z=fgetc(pr0fp); break;
							case 0x0ef5: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x0ef6: fputc(0x15,outfp); z=fgetc(pr0fp); break;
							case 0x0ef7: fputc(0xe0,outfp); z=fgetc(pr0fp); break;
							case 0x0f66: fputc(0xc3,outfp); z=fgetc(pr0fp); break;
							case 0x0f67: fputc(0x18,outfp); z=fgetc(pr0fp); break;
							case 0x0f68: fputc(0xe0,outfp); z=fgetc(pr0fp); break;
							case 0x1059: fputc(0x36,outfp); z=fgetc(pr1fp); break;
							case 0x105a: fputc(0xe0,outfp); z=fgetc(pr1fp); break;
							case 0x105b: fputc(0x02,outfp); z=fgetc(pr1fp); break;
							case 0x105c: fputc(0x03,outfp); z=fgetc(pr1fp); break;
							case 0x105d: fputc(0x04,outfp); z=fgetc(pr1fp); break;
							case 0x11ea: fputc(0x0a,outfp); z=fgetc(pr1fp); break;
							case 0x124d: fputc(0xcd,outfp); z=fgetc(pr1fp); break;
							case 0x124e: fputc(0x30,outfp); z=fgetc(pr1fp); break;
							case 0x124f: fputc(0xe0,outfp); z=fgetc(pr1fp); break;
							case 0x1250: fputc(0xc3,outfp); z=fgetc(pr1fp); break;
							case 0x1251: fputc(0xe6,outfp); z=fgetc(pr1fp); break;
							case 0x1252: fputc(0x12,outfp); z=fgetc(pr1fp); break;
							case 0x12f5: fputc(0x08,outfp); z=fgetc(pr1fp); break;
							case 0x145e: fputc(0x0a,outfp); z=fgetc(pr1fp); break;
							case 0x1922: fputc(0x04,outfp); z=fgetc(pr1fp); break;
							case 0x24a6: fputc(0xcd,outfp); z=fgetc(pr1fp); break;
							case 0x24a7: fputc(0x1e,outfp); z=fgetc(pr1fp); break;
							case 0x24a8: fputc(0xe0,outfp); z=fgetc(pr1fp); break;
							case 0x24a9: fputc(0x00,outfp); z=fgetc(pr1fp); break;
							case 0x24b2: fputc(0xcd,outfp); z=fgetc(pr1fp); break;
							case 0x24b3: fputc(0x1e,outfp); z=fgetc(pr1fp); break;
							case 0x24b4: fputc(0xe0,outfp); z=fgetc(pr1fp); break;
							case 0x24b5: fputc(0x00,outfp); z=fgetc(pr1fp); break;
							case 0x24e6: fputc(0xcd,outfp); z=fgetc(pr1fp); break;
							case 0x24e7: fputc(0x1b,outfp); z=fgetc(pr1fp); break;
							case 0x24e8: fputc(0xe0,outfp); z=fgetc(pr1fp); break;
							case 0x24e9: fputc(0x00,outfp); z=fgetc(pr1fp); break;
							case 0x2520: fputc(0xcd,outfp); z=fgetc(pr1fp); break;
							case 0x2521: fputc(0x1b,outfp); z=fgetc(pr1fp); break;
							case 0x2522: fputc(0xe0,outfp); z=fgetc(pr1fp); break;
							case 0x2523: fputc(0x00,outfp); z=fgetc(pr1fp); break;
							case 0x2536: fputc(0xc3,outfp); z=fgetc(pr1fp); break;
							case 0x2537: fputc(0x24,outfp); z=fgetc(pr1fp); break;
							case 0x2538: fputc(0xe0,outfp); z=fgetc(pr1fp); break;
							case 0x255e: fputc(0xc3,outfp); z=fgetc(pr1fp); break;
							case 0x255f: fputc(0x21,outfp); z=fgetc(pr1fp); break;
							case 0x2560: fputc(0xe0,outfp); z=fgetc(pr1fp); break;

							default:
								if (k == 3) {
									fputc(fgetc(pr0fp),outfp);
								} else {
									fputc(fgetc(pr1fp),outfp);
								}
								break;
						}
					}
					break;

				case  6:
/* track#6 -> p_b */
					for (j=0; j<256; j++ ) {
						fputc(fgetc(p_bfp),outfp);
					}
					break;

				case  7:
				case  8:
				case  9:
/* track#7,8,9 -> p_gr */
					for (j=0; j<256; j++ ) {
						fputc(fgetc(p_grfp),outfp);
					}
					break;

				case 10:
/* track#10 -> prog_p6_1 */
					for (j=0; j<256; j++ ) {
						fputc(fgetc(p6_1fp),outfp);
					}
					break;

				case 11:
/* track#11 -> prog_p6_2 */
					for (j=0; j<256; j++ ) {
						fputc(fgetc(p6_2fp),outfp);
					}
					break;

				case 22:
				case 23:
/* track#22,23 -> map01 */
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map01fp),outfp);
					}
					break;

				case 24:
				case 25:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map02fp),outfp);
					}
					break;

				case 26:
				case 27:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map03fp),outfp);
					}
					break;

				case 28:
				case 29:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map04fp),outfp);
					}
					break;

				case 30:
				case 31:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map05fp),outfp);
					}
					break;

				case 32:
				case 33:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map06fp),outfp);
					}
					break;

				case 34:
				case 35:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map07fp),outfp);
					}
					break;

				case 36:
				case 37:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map08fp),outfp);
					}
					break;

				case 38:
				case 39:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map09fp),outfp);
					}
					break;

				case 40:
				case 41:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map10fp),outfp);
					}
					break;

				case 42:
				case 43:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map11fp),outfp);
					}
					break;

				case 44:
				case 45:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map12fp),outfp);
					}
					break;

				case 46:
				case 47:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map13fp),outfp);
					}
					break;

				case 48:
				case 49:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map14fp),outfp);
					}
					break;

				case 50:
				case 51:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map15fp),outfp);
					}
					break;

				case 52:
				case 53:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map16fp),outfp);
					}
					break;

				case 54:
				case 55:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map17fp),outfp);
					}
					break;

				case 56:
				case 57:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map18fp),outfp);
					}
					break;

				case 58:
				case 59:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map19fp),outfp);
					}
					break;

				case 60:
				case 61:
					for (j=0; j<256; j++ ) {
						fputc(fgetc(map20fp),outfp);
					}
					break;

				default:
					for (j=0; j<256; j++ ) {
						fputc(0x00,outfp);
					}
					break;
			}

		}
	}


	fclose(iplfp);
	fclose(pr0fp);
	fclose(pr1fp);
	fclose(p_bfp);
	fclose(p_grfp);
	fclose(p6_1fp);
	fclose(p6_2fp);
	fclose(map01fp);
	fclose(map02fp);
	fclose(map03fp);
	fclose(map04fp);
	fclose(map05fp);
	fclose(map06fp);
	fclose(map07fp);
	fclose(map08fp);
	fclose(map09fp);
	fclose(map10fp);
	fclose(map11fp);
	fclose(map12fp);
	fclose(map13fp);
	fclose(map14fp);
	fclose(map15fp);
	fclose(map16fp);
	fclose(map17fp);
	fclose(map18fp);
	fclose(map19fp);
	fclose(map20fp);
	fclose(outfp);

	return(0);
}
