;
; dragon slayer for p6mk2
; additional program 2
;

SOUNDON		EQU	281ch		; SOUND ON/OFF[N
DISKERR_DISP	EQU	0ea8h		; fBXNG[\
MAPDRAW_MAIN	EQU	0852h		; 10x10}bv\iXVj
WAITLOOP_MAIN	EQU	04b4h		; ԑ҂
STATUS_MAIN	EQU	0a2ah		; STATUSl\
MSTATES_MAIN	EQU	0610h		; Gʂ̃NA
MOVEADD		EQU	2806h		; ړZl
MOVEADDTABLE	EQU	10d9h		; ړZle[u
MAINLOOP	EQU	013ah		; C[v
INITDISP	EQU	0288h		; ʕ\
MONSTDISP	EQU	03e7h		; G\iXVj
KEYRETURN	EQU	1cbeh		; L[͌̃^[AhX
PALETSET	EQU	7000h		; J[pbg̐ݒ
CLS		EQU	7003h		; ʃNA
PUTSTR		EQU	0d79h		; 16x8̕\
LOAD_STR	EQU	1c16h		; "NOW LOADING"
SAVE_STR	EQU	1c28h		; "NOW SAVING"
RESTART		EQU	1561h		; X^[g


	org	0e000h

	jp	KEYINT		; e000h
	jp	INTDT0		; e003h
	jp	INTDT1		; e006h
	jp	GAMEKEYINT	; e009h
	jp	TIMERINT	; e00ch
	jp	KEYIN		; e00fh
	jp	ISRETURN	; e012h
	jp	READFLOPPY	; e015h
	jp	WRITEFLOPPY	; e018h
	jp	SOUNDSTOP	; e01bh
	jp	BEEP		; e01eh
	jp	SOUNDHL		; e021h
	jp	SOUNDLL		; e024h
	jp	CLS_INFOSCR	; e027h
	jp	CLS_INFOMON	; e02ah
	jp	DRAWMAP		; e02dh
	jp	DRAWWARP	; e030h
	jp	WAITLOOP	; e033h
	jp	DISKMENU	; e036h

;
; 荞ݏI[iȂj
;
INTDT0:
	ei
	ret

;
; 荞ݏI[if[^PoCgM{Ȃj
;
INTDT1:
	push	af
	call	GETSUBCPU
	pop	af
	ei
	ret

;
; Q[L[荞
;
GAMEKEYINT:
	push	af
	call	GETSUBCPU
	ld	(GAMEKEYBUF),a
	pop	af
	ei
	ret

GAMEKEYBUF:
	db	00h

;
; ^C}荞
;
TIMERINT:
	push	af
	ld	a,06h
	call	SETSUBCPU
	pop	af
	ei
	ret


;
; TuCPUPoCgf[^M
;
; RETFAreg=Mf[^
;
GETSUBCPU:
	ld	a,0ch
	out	(093h),a
GETSUBCPU_WAIT:
	in	a,(092h)
	and	20h
	jr	z,GETSUBCPU_WAIT
	ld	a,0dh
	out	(093h),a
	in	a,(090h)
	ret

;
; TuCPUւPoCgf[^𑗐M
;
; Areg=Mf[^
;
SETSUBCPU:
	push	af
	ld	a,08h
	out	(093h),a
SETSUBCPU_WAIT:
	in	a,(092h)
	and	80h
	jr	z,SETSUBCPU_WAIT
	ld	a,09h
	out	(093h),a
	pop	af
	out	(090h),a
	ret

;
; L[͊荞
;
; GRAPH+L[̏ꍇ́AASCIIR[h
; t@NVL[̏ꍇ́Af0h`f9h
; STOPL[̏ꍇ́Afah
; ʏL[́AASCIIR[h
;
KEYINT:
	push	af
	call	GETSUBCPU
	ld	(KEYBUF),a
	pop	af
	ei
	ret

KEYBUF:	db	00h

;
; L[́{CTRL-S
;
KEYIN:
	push	hl
	push	de
	push	bc

	ld	a,(KEYBUF)
	ld	b,a
	xor	a
	ld	(KEYBUF),a

	ld	a,(GAMEKEYBUF)
	ld	c,a
	bit	1,c
	jr	z,KEYIN_L21
	ld	a,03h		; CTRL-C
	jr	KEYIN_ED2
KEYIN_L21:
	and	3ch
	jr	z,KEYIN_L3

		; J[\L[
	rrca
	rrca
	ld	e,a
	ld	d,0
	ld	hl,GAMEKEYTABLE
	add	hl,de

	ld	a,c
	and	81h		; SHIFT+SPACE
	ld	a,(hl)
	jr	z,KEYIN_ED2

	ld	b,'C'
	bit	7,c
	jr	z,KEYIN_L22
	ld	b,'X'

KEYIN_L22:
		; SHIFT+J[\L[iBREAK)
		; SPACE+J[\L[iKICK)

	sub	'1'
	add	a,a
	ld	e,a
	ld	d,0
	ld	hl,MOVEADDTABLE
	add	hl,de
	ld	d,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,d
	ld	(MOVEADD),hl

	ld	a,b
	jr	KEYIN_ED2

KEYIN_L3:
		; ʃL[
	ld	a,b
	cp	13h		; CTRL-S
	jr	nz,KEYIN_ED1
	ld	a,(SOUNDON)
	cpl
	ld	(SOUNDON),a
	jr	KEYIN_ZERO

KEYIN_ED1:
	cp	1ch
	jr	c,KEYIN_ED2
	cp	20h
	jr	c,KEYIN_ZERO
	cp	'a'
	jr	c,KEYIN_ED2
	cp	'z' + 1
	jr	nc,KEYIN_ED2
	sub	20h
	jr	KEYIN_ED2

KEYIN_ZERO:
	xor	a
KEYIN_ED2:
	pop	bc
	pop	de
	pop	hl
	ret

;b3-0 = 
GAMEKEYTABLE:
	db	00h	;
	db	'8'	; 
	db	'2'	; 
	db	'5'	; x
	db	'6'	; 
	db	'9'	; 
	db	'3'	; 
	db	'5'	; x
	db	'4'	; 
	db	'7'	; 
	db	'1'	; 
	db	'5'	; x
	db	'5'	; x
	db	'5'	; x
	db	'5'	; x
	db	'5'	; x


DISKMENU:
	ld	a,b
	cp	2
	jp	z,RESTART

	call	CLS		; ʃNA
	ld	a,08h
	call	PALETSET
DISKMENU_L1:
	call	KEYIN		; L[
	and	a
	jr	nz,DISKMENU_L1
	ld	ix,DISKMENU_STR	; LOADGAME/SAVEGAME
	call	PUTSTR		; \
DISKMENU_L2:
	call	KEYIN		; L[
	and	a
	jr	z,DISKMENU_L2
	cp	"L"
	jr	nz,DISKMENU_L3

		;
		; [hQ[
		;
	call	CLS
	ld	ix,LOAD_STR	; "NOW LOADING"
	call	PUTSTR
	call	LOADGAME	; [Nf[^ǂݍ
	call	INITDISP	; ʕ\
	pop	af		; CALLLZ
	jp	MAINLOOP	; C[v

DISKMENU_L3:
	cp	"S"
	jr	nz,DISKMENU_L4

		;
		; Z[uQ[
		;
	call	CLS
	ld	ix,SAVE_STR	; "NOW SAVING"
	call	PUTSTR
	call	SAVEGAME	; [Nf[^

DISKMENU_L4:
	call	INITDISP	; ʕ\
	call	MONSTDISP	; G\iXVj
	jp	KEYRETURN


DISKMENU_STR:
	DB	02H,19H		; \VRAMAhX
	DB	0FEH,05H	; \FVA
	DB	4BH
	;	 [

	DB	0FEH,03H	; \F}[^
	DB	15H
	;	 L

	DB	0FEH,05H	; \FVA
	DB	4CH,18H,0AH,0DH,3FH,10H,0AH,16H,0EH,3FH,0DH,0AH,1DH,0AH,0FFH
	;	 ]   O   A   D  " "  G   A   M   E  " "  D   A   T   A

	DB	42H,1FH		; \VRAMAhX
	DB	0FEH,05H	; \FVA
	DB	4BH
	;	 [

	DB	0FEH,03H	; \F}[^
	DB	1CH
	;	 S

	DB	0FEH,05H	; \FVA
	DB	4CH,0AH,1FH,0EH,3FH,10H,0AH,16H,0EH,3FH,0DH,0AH,1DH,0AH,0FFH
	;	 ]   A   V   E  " "  G   A   M   E  " "  D   A   T   A

	DB	0FFH,0FFH


;
; [hQ[
;
LOADGAME:
	push	hl
	push	de
	push	bc
	push	af

		;
		; [Nf[^[h
		;
LOADGAME_L1:
	ld	hl,0c000h
	ld	de,1003h	; gbNԍ^ZN^ԍ
	ld	c,02h		; ǂݍރZN^
	call	READFLOPPY
	call	c,DISKERR_DISP
	jr	c,LOADGAME_L1
	ld	hl,0c000h
	ld	de,2800h
	ld	bc,0800h
	ldir

		;
		; }bvf[^[h
		;
LOADGAME_L2:
	ld	hl,0c000h
	ld	de,1101h	; gbNԍ^ZN^ԍ
	ld	c,08h		; ǂݍރZN^
	call	READFLOPPY
	call	c,DISKERR_DISP
	jr	c,LOADGAME_L2

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

;
; Z[uQ[
;
SAVEGAME:
	push	hl
	push	de
	push	bc
	push	af

		;
		; }bvf[^Z[u
		;
SAVEGAME_L1:
	ld	hl,0c000h
	ld	de,1101h	; gbNԍ^ZN^ԍ
	ld	c,08h		; ǂݍރZN^
	call	WRITEFLOPPY
	call	c,DISKERR_DISP
	jr	c,SAVEGAME_L1

		;
		; [Nf[^Z[u
		;
	ld	hl,2800h
	ld	de,0c000h
	ld	bc,0800h
	ldir
SAVEGAME_L2:
	ld	hl,0c000h
	ld	de,1003h	; gbNԍ^ZN^ԍ
	ld	c,02h		; ǂݍރZN^
	call	WRITEFLOPPY
	call	c,DISKERR_DISP
	jr	c,SAVEGAME_L2

	jr	LOADGAME_L2


;
; tbs[ǂݍ
;
; DregFgbNԍ
; EregFZN^ԍ
; CregFǂݍރZN^
; HLregFi[AhX
;
; RETFCflag=1 G[
; Dreg/EregFǂݍ񂾃ZN^i
;

READFLOPPY:
	push	af

	ld	a,0b7h		; or	a
	ld	(RF_WR),a

WRFLOPPY:
	push	ix
	push	bc

	ld	a,011h
	out	(0f0h),a
	ld	ix,0f9d2h

	push	bc
	push	hl
	push	de
	pop	bc		; gbNԍ^ZN^ԍ
	pop	de		; i[AhX
	pop	hl		; ZN^iLregj

	sla	l		; x2
	sla	l		; x4iZN^j

	dec	c
	sla	c		; x2
	sla	c		; x4
	inc	c		; ZN^ԍ

RF_L2:
	xor	a
	ld	(ix+0),a	; hCuԍ
	ld	(ix+27),a	; G[JE^

	ld	a,01h		; ZN^
RF_WR:	or	a
	push	de
	push	bc
	call	4274h
	pop	bc
	pop	de
	jr	c,RF_ERR
	inc	d
	inc	c
	ld	a,c
	cp	11h
	jr	nz,RF_L1
	ld	c,01h
	inc	b
RF_L1:	dec	l
	jr	nz,RF_L2

	push	de		; i[AhX
	push	bc		; gbNԍ^ZN^ԍ
	pop	de
	pop	hl

	pop	bc
	pop	ix

	ld	a,0ddh
	out	(0f0h),a

	pop	af
	scf
	ccf
	ret


RF_ERR:
	pop	bc
	pop	ix

	ld	a,0ddh
	out	(0f0h),a

	pop	af
	scf
	ret

;
; tbs[
;

WRITEFLOPPY:
	push	af

	ld	a,037h		; scf
	ld	(RF_WR),a

	jr	WRFLOPPY

;
; RETURN L[͂ǂH
;
ISRETURN:
	call	KEYIN
	cp	0dh
	ret


;
;y~߂
;
SOUNDSTOP:
	ld	a,8
	out	(0a0h),a
	xor	a
	out	(0a1h),a
	ret

;
;BEEP炷(2400Hz)
;
BEEP:
	ld	a,00h
	out	(0a0h),a
	ld	a,52
	out	(0a1h),a	; R0 = 52
	ld	a,01h
	out	(0a0h),a
	xor	a
	out	(0a1h),a	; R1 = 0
	ld	a,08h
	out	(0a0h),a
	ld	a,0fh
	out	(0a1h),a	; R8=15
	ld	a,07h
	out	(0a0h),a
	ld	a,0beh
	out	(0a1h),a	; R7=TONE-A
	ret

;
;"H"+"L"oSUB
;
SOUNDHL:
	push	bc
	ld	c,0fh

	call	SOUND_SUB

	pop	bc
	ret

;
;"L"+"L"oSUB
;
SOUNDLL:
	push	bc
	ld	c,00h

	call	SOUND_SUB

	pop	bc
	ret


;
;"H"+"L"/"L"+"L"oSUB
;
; "H"FBreg
; "L"FBreg
; "H"+"L"FDEreg
;
; PC88
; F = Breg x 110 @ 4MHz  Breg=1 ̎AF = 4/110 = 1/22.5 MHz
;
; PSG
; F = TP x 16 @ 2MHz  TP=1 ̎AF = 2/16 = 1/8 MHz
;
; TP = Breg x 55 / 16  Breg x 56 / 16 = Breg x 7 / 2
;

SOUND_SUB:
	push	hl
	push	de
	ld	l,b
	ld	h,00h
	add	hl,hl		; x 2
	ld	e,l
	ld	d,h
	add	hl,hl		; x 4
	add	hl,de		; x 6
	ld	e,b
	ld	d,00h
	add	hl,de		; x 7
	srl	h
	rr	l		; x 7 / 2

	ld	a,00h
	out	(0a0h),a
	ld	a,l
	out	(0a1h),a	; R0,R1 = Breg x 7 / 2
	ld	a,01h
	out	(0a0h),a
	ld	a,h
	out	(0a1h),a	; R0,R1 = Breg x 7 / 2
	ld	a,08h
	out	(0a0h),a
	ld	a,c
	out	(0a1h),a	; R8=Creg
	ld	a,07h
	out	(0a0h),a
	ld	a,0beh
	out	(0a1h),a	; R7=TONE-A

	pop	de
	pop	hl

	srl	d
	rr	e
SOUNDSUB_L1:
	dec	de
	ld	a,d
	or	e
	jr	nz,SOUNDSUB_L1

	ret


;
; ʑS̃NA
;
CLS_INFOSCR:
	push	iy
	push	ix
	push	hl
	push	de
	push	bc
	push	af

	ld	c,0c8h

	ld	ix,08019h
	ld	iy,0a019h
CLS_INFOSCR_L11:
	ld	b,0fh
CLS_INFOSCR_L10:
	ld	(ix+0),000h
	ld	(iy+0),0ffh
	inc	ix
	inc	iy
	djnz	CLS_INFOSCR_L10
	ld	de,0019h
	add	ix,de
	add	iy,de
	dec	c
	jr	nz,CLS_INFOSCR_L11

			; ij
	ld	hl,0a019h
	ld	de,INFOSCR_DAT_L
	ld	c,25
CLS_INFOSCR_LL1:
	push	de
	ld	b,8
CLS_INFOSCR_LL0:
	ld	a,(de)
	inc	de
	ld	(hl),a
	push	de
	ld	de,40
	add	hl,de
	pop	de
	djnz	CLS_INFOSCR_LL0
	pop	de
	dec	c
	jr	nz,CLS_INFOSCR_LL1

			; iEj
	ld	hl,0a027h
	ld	de,INFOSCR_DAT_R
	ld	c,25
CLS_INFOSCR_LR1:
	push	de
	ld	b,8
CLS_INFOSCR_LR0:
	ld	a,(de)
	inc	de
	ld	(hl),a
	push	de
	ld	de,40
	add	hl,de
	pop	de
	djnz	CLS_INFOSCR_LR0
	pop	de
	dec	c
	jr	nz,CLS_INFOSCR_LR1

			; ij
	ld	hl,0a019h
	ld	de,INFOSCR_DAT_U
	ld	c,04
CLS_INFOSCR_LU1:
	ld	b,15
	ld	a,(de)
	inc	de
CLS_INFOSCR_LU0:
	ld	(hl),a
	inc	hl
	djnz	CLS_INFOSCR_LU0
	push	de
	ld	de,25
	add	hl,de
	pop	de
	dec	c
	jr	nz,CLS_INFOSCR_LU1

			; ij
	ld	hl,0bf31h
	ld	de,INFOSCR_DAT_D
	ld	c,04
CLS_INFOSCR_LD1:
	ld	b,15
	ld	a,(de)
	inc	de
CLS_INFOSCR_LD0:
	ld	(hl),a
	inc	hl
	djnz	CLS_INFOSCR_LD0
	push	de
	ld	de,25+0ffb0h
	add	hl,de
	pop	de
	dec	c
	jr	nz,CLS_INFOSCR_LD1


	call	0a2ah		; STATUSl\
	call	0610h		; Gʂ̃NA

		; X^[ʂ̍Eɏ
	ld	ix,09789h
	ld	iy,0b789h
	ld	b,36
	ld	de,40
CLS_INFOSCR_L3:
	set	1,(ix+0)
	res	0,(ix+0)
	set	1,(iy+0)
	res	0,(iy+0)
	set	7,(ix+14)
	res	6,(ix+14)
	set	7,(iy+14)
	res	6,(iy+14)
	add	ix,de
	add	iy,de
	djnz	CLS_INFOSCR_L3

		; X^[ʂ̏ɏ
	ld	ix,0978ah
	ld	iy,0b78ah
	ld	b,13
CLS_INFOSCR_L4:
	ld	(ix+0),0aah
	ld	(iy+0),0aah
	inc	ix
	inc	iy
	djnz	CLS_INFOSCR_L4

		; X^[ʂ̉ɏ
	ld	ix,09d02h
	ld	iy,0bd02h
	ld	b,13
CLS_INFOSCR_L5:
	ld	(ix+0),0aah
	ld	(iy+0),0aah
	inc	ix
	inc	iy
	djnz	CLS_INFOSCR_L5

	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ix
	pop	iy

	ret

INFOSCR_DAT_L:
	db	0bfh		; ".ooo"
	db	0afh		; "..oo"
	db	0afh		; "..oo"
	db	0afh		; "..oo"
	db	0bfh		; ".ooo"
	db	0efh		; "o.oo"
	db	0afh		; "..oo"
	db	0afh		; "..oo"

INFOSCR_DAT_R:
	db	0fah		; "oo.."
	db	0fah		; "oo.."
	db	0fbh		; "oo.o"
	db	0feh		; "ooo."
	db	0fah		; "oo.."
	db	0fah		; "oo.."
	db	0fah		; "oo.."
	db	0feh		; "ooo."

INFOSCR_DAT_U:
	db	0aah		; "...."
	db	0aeh		; "..o."
	db	0abh		; "...o"
	db	0bbh		; ".o.o"

INFOSCR_DAT_D:
	db	0aah		; "...."
	db	0bah		; ".o.."
	db	0eah		; "o..."
	db	0eeh		; "o.o."

;
; X^[ʃNA
;
CLS_INFOMON:
	push	iy
	push	ix
	push	de
	push	bc

	ld	c,34

	ld	ix,097b2h
	ld	iy,0b7b2h
CLS_INFOMON_L11:
	ld	b,13
CLS_INFOMON_L10:
	ld	(ix+0),00h
	ld	(iy+0),00h
	inc	ix
	inc	iy
	djnz	CLS_INFOMON_L10
	ld	de,001bh
	add	ix,de
	add	iy,de
	dec	c
	jr	nz,CLS_INFOMON_L11

	pop	bc
	pop	de
	pop	ix
	pop	iy
	ret

;
; MAPp̃hbg`iQ~Shbgj
; AregFFi0b00000GRBj
; HLregFVRAMAhXi0xC000`j
DRAWMAP:
	push	hl
	push	de
	push	bc
	push	af

	or	08h
	ld	e,a

	and	03h
	ld	d,a	; 000000RB
	rlca
	rlca
	or	d	; 0000RBRB
	ld	d,a

	ld	a,e
	and	0ch
	ld	e,a	; 0000HG00
	rlca
	rlca
	or	e	; 00HGHG00
	rlca
	rlca		; HGHG0000
	ld	e,a

	ld	bc,04000h
	add	hl,bc

	srl	h
	rr	l
	ex	af,af'

	ld	bc,08000h
	add	hl,bc

	ex	af,af'

	jr	c,DRAWMAP_L1

	rlc	d
	rlc	d
	rlc	d
	rlc	d

	ld	bc,40

	ld	a,(hl)
	and	0fh
	or	d
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0fh
	or	d
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0fh
	or	d
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0fh
	or	d
	ld	(hl),a

	ld	bc,02000h-120
	add	hl,bc

	ld	bc,40

	ld	a,(hl)
	and	0fh
	or	e
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0fh
	or	e
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0fh
	or	e
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0fh
	or	e
	ld	(hl),a

	jr	DRAWMAP_L2

DRAWMAP_L1:
	rlc	e
	rlc	e
	rlc	e
	rlc	e

	ld	bc,40

	ld	a,(hl)
	and	0f0h
	or	d
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0f0h
	or	d
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0f0h
	or	d
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0f0h
	or	d
	ld	(hl),a

	ld	bc,02000h-120
	add	hl,bc

	ld	bc,40

	ld	a,(hl)
	and	0f0h
	or	e
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0f0h
	or	e
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0f0h
	or	e
	ld	(hl),a
	add	hl,bc

	ld	a,(hl)
	and	0f0h
	or	e
	ld	(hl),a

DRAWMAP_L2:
	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

;
; [vo
;
DRAWWARP:
	ld	hl,8faah
	ld	c,0
DRAWWARP_L3:
	ld	(DRAWWARP_WORK),hl
	ld	a,c
	sla	a
	add	a,2
	ld	b,a
DRAWWARP_L1:
	ld	(hl),0aah	; 
	inc	hl
	djnz	DRAWWARP_L1
	ld	a,(hl)
	and	0fh
	or	0a0h		; 
	ld	(hl),a

	ld	a,c
	sla	a
	sla	a
	sla	a
	sla	a
	add	a,19
	ld	b,a
	ld	ix,(DRAWWARP_WORK)
	ld	de,40

DRAWWARP_L2:
	add	ix,de
	add	hl,de
	set	7,(ix+0)
	set	5,(hl)
	djnz	DRAWWARP_L2

	ld	hl,(DRAWWARP_WORK)
	ld	de,0febfh		; - (40*8+1)
	add	hl,de
	inc	c
	ld	a,c
	cp	11
	jr	nz,DRAWWARP_L3

	ld	a,0ffh			;
	call	WAITLOOP_MAIN		; ԑ҂

	ld	hl,(DRAWWARP_WORK)
	ld	c,10
DRAWWARP_L6:
	ld	(DRAWWARP_WORK),hl
	ld	a,c
	sla	a
	add	a,2
	ld	b,a
DRAWWARP_L4:
	ld	(hl),055h	; 
	inc	hl
	djnz	DRAWWARP_L4
	ld	a,(hl)
	and	0fh
	or	050h		; 
	ld	(hl),a

	ld	a,c
	sla	a
	sla	a
	sla	a
	sla	a
	add	a,19
	ld	b,a
	ld	ix,(DRAWWARP_WORK)
	ld	de,40

DRAWWARP_L5:
	add	ix,de
	add	hl,de
	res	7,(ix+0)
	res	5,(hl)
	djnz	DRAWWARP_L5

	ld	hl,(DRAWWARP_WORK)
	ld	de,321			; 40*8+1
	add	hl,de
	ld	a,c
	sub	1
	ld	c,a
	jr	nc,DRAWWARP_L6

	jp	MAPDRAW_MAIN	; 10x10}bv\iXVj

DRAWWARP_WORK:
	db	00h,00h



;
; ԑ҂
; AregF[v
;
WAITLOOP:
	push	af
WAITLOOP_L2:
	push	af
	ld	a,20h
WAITLOOP_L1:
	dec	a
	jp	nz,WAITLOOP_L1
	pop	af
	dec	a
	jp	nz,WAITLOOP_L2
	pop	af
	ret


	org	0e600h
	db	00h

	org	0efffh
	db	00h

	end
