;
; dragon slayer for p6mk2
; additional program 1
;

CHR_C_ADD	EQU	281ah
PALETTABLE	EQU	0d19h

	org	07000h

	jp	PALETSET	; 7000h
	jp	CLS		; 7003h
	jp	CHRPUT		; 7006h
	jp	CHR_B		; 7009h
	jp	CHR_BINV	; 700ch
	jp	CHR_GR		; 700fh
	jp	CHR_GRINV	; 7012h

;
; ʃLN^ԍi[obt@
;
; ォBʁAGRʁA
;
CHRNUMBUF:
	db	101	dup (00h,00h)	; BʁAGRʁA

;
; PALETύX
;
PALETSET:
	push	hl
	push	de
	push	bc
	push	af

	call	PALETSETSUB
	jr	z,PALETSET_END

	ld	a,(09f3fh)
	ld	(DMABUF+0),a
	ld	a,(0bf3fh)
	ld	(DMABUF+1),a
	xor	a
	ld	(09f3fh),a
	ld	(0bf3fh),a
	ld	a,02h
	out	(93h),a

	ld	hl,0000h
	ld	de,CHRNUMBUF

	ld	b,10
PALETSET_L2:
	push	bc

	ld	b,10
PALETSET_L1:
	push	bc

	push	de
	call	CHR_ALL_SUB
	pop	de

	inc	de
	inc	de
	ld	bc,5
	add	hl,bc

	pop	bc
	djnz	PALETSET_L1

	ld	bc,1600-50
	add	hl,bc

	pop	bc
	djnz	PALETSET_L2

	ld	a,(DMABUF+0)
	ld	(09f3fh),a
	ld	a,(DMABUF+1)
	ld	(0bf3fh),a
	ld	a,03h
	out	(93h),a

PALETSET_END:
	pop	af
	pop	bc
	pop	de
	pop	hl

	ret

;
; PALETݒTu
;
; RET:OƓlݒ肳ꂽAZflag=1

PALETSETSUB:
	push	af

	push	af

	ld	l,a
	ld	h,00h
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	ld	bc,PALETTABLE
	add	hl,bc
	ld	a,(hl)
	ld	(CHR_FCOLOR+1),a	; wiF
	ld	de,PALETDAT
	ld	bc,0008h
	ldir

	pop	af

	ld	l,a
	ld	h,00h
	add	hl,hl		; x2
	add	hl,hl		; x4
	ld	de,PALETRGBTABLE
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ex	de,hl
	ld	(CHR_CLS_DAT_B+1),hl		; ʃNAF
	ld	(CHR_NN_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_BSUB_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_BSUB_HDAT_DAT_B+1),hl	; 16x20 wiF
	ld	(CHR_BINVSUB_DAT_B+1),hl	; 16x20 wiF
	ld	(CHR_GRSUB_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_GRINVSUB_DAT_B+1),hl	; 16x20 wiF
	ld	(CHR_BGRSUB_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_BGRINVSUB_DAT_B+1),hl	; 16x20 wiF
	ex	de,hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ld	(CHR_BSUB_DAT_F+1),hl		; 16x20 LF
	ld	(CHR_BSUB_HDAT_DAT_F+1),hl	; 16x20 LF
	ld	(CHR_BINVSUB_DAT_F+1),hl	; 16x20 LF
	ld	(CHR_BGRSUB_DAT_F+1),hl		; 16x20 LF
	ld	(CHR_BGRINVSUB_DAT_F+1),hl	; 16x20 LF

	call	CHR_BSUB_HDAT

	ld	a,(PALETBEF)
	ld	b,a
	pop	af
	ld	(PALETBEF),a
	cp	a,b

	ret

PALETDAT:
	db	0,1,2,3,4,5,6,7		; ݂̃pbg̏

PALETRGBTABLE:
					; Areg	: wiF    / BLF
	db	0aah,055h,0ffh,000h	; 0	: HGRB=1001 / 1100
	db	0aah,000h,0ffh,000h	; 1	: HGRB=1000 / 1100
	db	0ffh,0aah,0ffh,000h	; 2	: HGRB=1110 / 1100
	db	0ffh,0aah,0ffh,000h	; 3	: HGRB=1110 / 1100
	db	0aah,055h,0aah,0aah	; 4	: HGRB=1001 / 1010
	db	0aah,000h,0aah,0aah	; 5	: HGRB=1000 / 1010
	db	0ffh,0aah,0aah,0aah	; 6	: HGRB=1110 / 1010
	db	0ffh,0aah,0aah,0aah	; 7	: HGRB=1110 / 1010
	db	0aah,000h,0aah,055h	; 8	: HGRB=1000 / 1001
	db	0aah,055h,0aah,055h	; 9	: HGRB=1001 / 1001
	db	0aah,0ffh,0ffh,055h	; 10	: HGRB=1011 / 1101
	db	0aah,000h,0aah,000h	; 11	: HGRB=1000 / 1000

PALETBEF:
	db	0ffh			; Õpbgݒl

DMABUF:
	db	00h,00h			; ʑҔp




CHR_FCOLOR:
	db	7,0	; F^wiF

CHR_CLSCOLOR:
	db	0	; ʃNAF

;
; ʑS̃NA
;
CLS:

CHR_CLS_DAT_B:
	ld	de,0000h	; wiFiDregFRBAEregFHGj

	push	de

	ld	hl,8000h
	ld	(hl),d
	ld	de,8001h
	ld	bc,1fffh
	ldir

	pop	de

	ld	hl,0a000h
	ld	(hl),e
	ld	de,0a001h
	ld	bc,1fffh
	ldir

	ld	hl,CHRNUMBUF
	ld	b,202
CLS_L1:	ld	(hl),00h
	inc	hl
	djnz	CLS_L1

	ret


;
; 4x8 p^[`
;
; hl	; `VRAM擪AhX
; a	; LN^ԍiLN^AhX́A0x3A00`j
;
CHRPUT:


;
; mod 80 A50`79 ̎AwiFIɗ΂ɂ
;
	push	hl
	push	de
	push	bc
	push	af

	push	hl
	push	af

	ld	a,(CHR_FCOLOR+1)
	ld	(CHR_BCOLOR_BUF),a

	ld	a,(PALETBEF)
	cp	08h
	jr	z,CHRPUT_L3


	ld	de,2800h		; 80 Ŋ
	ld	bc,0800h
CHRPUT_L2:
	sla	c
	inc	c
	or	a
	sbc	hl,de
	jr	nc,CHRPUT_L1
	add	hl,de
	dec	c
CHRPUT_L1:
	srl	d
	rr	e
	djnz	CHRPUT_L2

		; CregFALregF]

	ld	a,l
	cp	50
	jr	c,CHRPUT_L3

	ld	b,04h
	ld	a,c
	cp	151
	jr	c,CHRPUT_L4
	cp	186
	jr	nc,CHRPUT_L4
	ld	b,00h
CHRPUT_L4:
	ld	a,b
	ld	(CHR_FCOLOR+1),a

CHRPUT_L3:
	pop	af
	pop	hl

	call	CHRPUTSUB
	ld	a,(CHR_BCOLOR_BUF)
	ld	(CHR_FCOLOR+1),a

	pop	af
	pop	bc
	pop	de
	pop	hl
	ret

CHR_BCOLOR_BUF:
	db	00h

;
; 4x8 p^[`SUB
;
; hl	; `VRAM擪AhX
; a	; LN^ԍiLN^AhX́A0x3A00`j
;
CHRPUTSUB:
	ld	c,a

	ex	de,hl

	ld	a,(CHR_C_ADD)
	ld	hl,PALETDAT
	add	a,l
	ld	l,a
	ld	a,h
	adc	a,00h
	ld	h,a
	ld	a,(hl)

	ld	(CHR_FCOLOR),a

	ld	hl,3fffh
	or	a
	sbc	hl,de
	ret	c

	ld	l,c
	ld	h,00h
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	add	hl,hl		; x16
	ld	bc,3a00h	; LN^擪AhX
	add	hl,bc

	ex	de,hl

	ex	af,af'
	srl	h
	rr	l

	jr	nc,CHRSUB_L3
	inc	de
	scf
CHRSUB_L3:
	ex	af,af'

	ld	a,h
	add	a,80h
	ld	h,a

	ld	b,8		; c[v
CHRSUB_L1:
	push	bc

	ld	a,(de)
	ld	b,a
	cpl
	ld	c,a

	push	de
	push	hl

	ld	de,0000h

	ld	hl,(CHR_FCOLOR)	; l:FCOLOR h:BCOLOR
	bit	0,l
	jr	z,CHRSUB_F1
		; B
	ld	a,b
	and	055h
	or	d
	ld	d,a

CHRSUB_F1:
	bit	1,l
	jr	z,CHRSUB_F2
		; R
	ld	a,b
	and	0aah
	or	d
	ld	d,a

CHRSUB_F2:
	bit	2,l
	jr	z,CHRSUB_B0
		; G
	ld	a,b
	and	055h
	or	e
	ld	e,a

CHRSUB_B0:
	bit	0,h
	jr	z,CHRSUB_B1
		; B
	ld	a,c
	and	055h
	or	d
	ld	d,a

CHRSUB_B1:
	bit	1,h
	jr	z,CHRSUB_B2
		; R
	ld	a,c
	and	0aah
	or	d
	ld	d,a

CHRSUB_B2:
	bit	2,h
	jr	z,CHRSUB_RGB
		; G
	ld	a,c
	and	055h
	or	e
	ld	e,a

CHRSUB_RGB:
	ld	a,e
	or	0aah
	ld	e,a

	pop	hl

	ex	af,af'
	jr	c,CHRSUB_PAT2
	ex	af,af'

	ld	(hl),d		; RB
	ld	bc,2000h
	add	hl,bc
	ld	(hl),e		; HG
	ld	bc,0e028h	; - 0x2000 + 40
	add	hl,bc

	jr	CHRSUB_L2

CHRSUB_PAT2:
	ex	af,af'
	ld	a,(hl)		; RB
	and	0f0h
	ld	b,a
	ld	a,d
	and	0fh
	or	b
	ld	(hl),a		; RB
	inc	hl
	ld	a,(hl)		; RB
	and	0fh
	ld	b,a
	ld	a,d
	and	0f0h
	or	b
	ld	(hl),a		; RB
	ld	bc,1fffh
	add	hl,bc
	ld	a,(hl)		; HG
	and	0f0h
	ld	b,a
	ld	a,e
	and	0fh
	or	b
	ld	(hl),a		; HG
	inc	hl
	ld	a,(hl)		; HG
	and	0fh
	ld	b,a
	ld	a,e
	and	0f0h
	or	b
	ld	(hl),a		; HG
	ld	bc,0e027h	; - 0x2000 - 1 + 40
	add	hl,bc

CHRSUB_L2:

	pop	de
	inc	de
	inc	de

	pop	bc
	dec	b
	jp	nz,CHRSUB_L1

	ret


;
; 10x20 p^[`敪
;
; hl	F`VRAM擪AhX
; de	Fobt@AhX
;
CHR_ALL_SUB:
	inc	de
	ld	a,(de)		; GR
	or	a
	jr	nz,CHR_ALL_L1
	dec	de
	ld	a,(de)		; B
	or	a

	jp	z,CHR_NN_SUB	; B=0,GR=0

	bit	7,a
	jp	z,CHR_BSUB	; B<>0,GR=0	Areg <= Cb
	jp	CHR_BINVSUB	; B<>0,GR=0	Areg <= Cb

CHR_ALL_L1:
	cp	18h

	jr	c,CHR_ALL_L2

	bit	7,a
	jp	z,CHR_GRSUB	; GR>=18h	Areg <= Cgr
	jp	CHR_GRINVSUB	; GR>=18h	Areg <= Cgr

CHR_ALL_L2:
	ex	af,af'
	dec	de
	ld	a,(de)
	ld	e,a
	ex	af,af'

	jp	CHR_BGR_SUB	; 1<=GR<=17h	Areg <= Cgr,Ereg <= Cb

;
; 10x20 p^[`iu[j
;
; a	; BLUE ̃LN^ԍ
; hl	; `VRAM擪AhX
;
CHR_B:
	push	de
	push	af

CHR_B_L2:
	call	CALCBUFADD
	call	c,CHR_BSUB	; Areg <= Cb
	jr	c,CHR_B_L1

	ld	(de),a
	jr	nz,CHR_B_L3

	call	BCOLOR_SET
	call	CHR_ALL_SUB
	call	BCOLOR_RESET
	jr	CHR_B_L1

CHR_B_L3:
	call	CHR_ALL_SUB

CHR_B_L1:
	pop	af
	pop	de
	ret


;
; 10x20 p^[`iu[]j
;
; a	; BLUE ̃LN^ԍ
; hl	; `VRAM擪AhX
;
CHR_BINV:
	push	de
	push	af

	or	80h
	jr	CHR_B_L2

;
; 10x20 p^[`iO[{bhj
;
; a	; BLUE ̃LN^ԍ
; hl	; `VRAM擪AhX
;
CHR_GR:
	push	de
	push	af

CHR_GR_L2:
	call	CALCBUFADD
	call	c,CHR_GRSUB	; Areg <= Cgr
	jr	c,CHR_GR_L1

	inc	de
	ld	(de),a
	dec	de

	jr	nz,CHR_GR_L3

	call	BCOLOR_SET
	call	CHR_ALL_SUB
	call	BCOLOR_RESET
	jr	CHR_GR_L1


CHR_GR_L3:
	call	CHR_ALL_SUB

CHR_GR_L1:
	pop	af
	pop	de
	ret


;
; 10x20 p^[`iO[{bh]j
;
; a	; BLUE ̃LN^ԍ
; hl	; `VRAM擪AhX
;
CHR_GRINV:
	push	de
	push	af

	or	80h
	jr	CHR_GR_L2


;
; wiFw
;
BCOLOR_SET:
	push	hl

	ld	hl,(CHR_CLS_DAT_B+1)		; ʃNAF
	ld	(BCOLOR_SETBUF),hl

	ld	hl,(PALETRGBTABLE+4)		; F

	ld	(CHR_CLS_DAT_B+1),hl		; ʃNAF
	ld	(CHR_NN_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_BSUB_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_BINVSUB_DAT_B+1),hl	; 16x20 wiF
	ld	(CHR_GRSUB_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_GRINVSUB_DAT_B+1),hl	; 16x20 wiF
	ld	(CHR_BGRSUB_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_BGRINVSUB_DAT_B+1),hl	; 16x20 wiF

	pop	hl
	ret

BCOLOR_SETBUF:
	db	00h,00h

;
; wiF
;
BCOLOR_RESET:
	push	hl

	ld	hl,(BCOLOR_SETBUF)

	ld	(CHR_CLS_DAT_B+1),hl		; ʃNAF
	ld	(CHR_NN_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_BSUB_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_BINVSUB_DAT_B+1),hl	; 16x20 wiF
	ld	(CHR_GRSUB_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_GRINVSUB_DAT_B+1),hl	; 16x20 wiF
	ld	(CHR_BGRSUB_DAT_B+1),hl		; 16x20 wiF
	ld	(CHR_BGRINVSUB_DAT_B+1),hl	; 16x20 wiF

	pop	hl
	ret


;
; VRAMobt@AhXϊ
;
; hl	; `VRAM擪AhXi0x0000`0x3E7Fj
;
; RET
; de	; obt@AhX
; Cflag	; 1=͈͊O
; Zflag	; 1=ʁiAhX=30f6hj

; +   0   0   5  0a  0f  14  19  1e  23  28  2d
; + 640
; + c80
; +12c0
; +1900
; +1f40
; +2580
; +2bc0
; +3200
; +3840

CALCBUFADD:
	push	hl
	push	bc
	push	af

	push	hl
	ld	de,30f6h	; p[^\̓G\
	or	a
	sbc	hl,de
	pop	hl
	jr	nz,CALCBUFADD_L0

	ld	hl,200
	ld	de,CHRNUMBUF
	add	hl,de

	ex	de,hl

	pop	af
	pop	bc
	ld	h,1
	dec	h		; Zflag=1
	scf			; Cflag=1
	ccf			; Cflag=0
	pop	hl
	ret


CALCBUFADD_L0:
	ld	a,0ech		; -20
	ld	b,10

CALCBUFADD_L1:
	add	a,20
	ld	de,1600
	or	a
	sbc	hl,de
	jr	c,CALCBUFADD_L11
	djnz	CALCBUFADD_L1
	jr	CALCBUFADD_ERR

CALCBUFADD_L11:
	add	hl,de

	sub	a,2
	ld	b,10

CALCBUFADD_L2:
	add	a,2
	ld	de,5
	or	a
	sbc	hl,de
	jr	c,CALCBUFADD_L21
	djnz	CALCBUFADD_L2
	jr	CALCBUFADD_ERR

CALCBUFADD_L21:
	or	a
	adc	hl,de
	jr	nz,CALCBUFADD_ERR

	ld	l,a
	ld	h,00
	ld	de,CHRNUMBUF
	add	hl,de

	ex	de,hl

	pop	af
	pop	bc
	ld	h,2
	dec	h		; Zflag=0
	scf			; Cflag=1
	ccf			; Cflag=0
	pop	hl
	ret

CALCBUFADD_ERR:
	pop	af
	pop	bc
	ld	h,2
	dec	h		; Zflag=0
	scf			; Cflag=1
	pop	hl
	ret

;
; 10x20 p^[`TuiLN^ԍOj
;
; hl	; `VRAM擪AhX
;
CHR_NN_SUB:
	push	hl
	push	de
	push	bc
	push	af

	srl	h
	rr	l
	ex	af,af'

	push	hl
	ld	bc,8000h
	add	hl,bc		; RBVRAMAhX
	exx
	pop	hl
	ld	bc,0a000h
	add	hl,bc		; HGVRAMAhX
	exx

CHR_NN_DAT_B:
	ld	de,0000h	; wiFiDregFRBAEregFHGj

	ex	af,af'
	ld	a,20		; c20hbg
	jr	c,CHR_NN_SUB_L1

CHR_NN_SUB_L2:
	push	af

	ld	(hl),d
	inc	hl
	ld	(hl),d
	inc	hl
	ld	a,(hl)
	and	0fh
	ld	c,a
	ld	a,d
	and	0f0h
	or	c
	ld	(hl),a

	ld	a,e
	exx
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	exx
	and	0fh
	ld	c,a
	ld	a,e
	and	0f0h
	or	c
	exx
	ld	(hl),a
	ld	bc,38
	add	hl,bc
	exx

	ld	bc,38
	add	hl,bc

	pop	af
	dec	a
	jr	nz,CHR_NN_SUB_L2
	jr	CHR_NN_SUB_RET

CHR_NN_SUB_L1:
	push	af

	ld	a,(hl)
	and	0f0h
	ld	c,a
	ld	a,d
	and	0fh
	or	c
	ld	(hl),a
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),d

	exx
	ld	a,(hl)
	exx
	and	0f0h
	ld	c,a
	ld	a,e
	and	0fh
	or	c
	exx
	ld	(hl),a
	inc	hl
	exx
	ld	a,e
	exx
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ld	bc,38
	add	hl,bc
	exx

	ld	bc,38
	add	hl,bc

	pop	af
	dec	a
	jr	nz,CHR_NN_SUB_L1

CHR_NN_SUB_RET:
	pop	af
	pop	bc
	pop	de
	pop	hl

	ret

;
; 10x20 p^[`Tuiu[j
;
; a	; BLUE ̃LN^ԍ
; hl	; `VRAM擪AhX
;
; i[p^[ihbgL"11"Ahbg"00"j
; 0`9Ƃ
; 0123 / 4566 / 8901 / 2345 / 6789
;
; LN^ԍȉ̂̂́AłR[
; 01,02,03,04,05,06
; 12,13,14,15,16,17,18,19
; 22,23
CHR_BSUB:
	cp	7
	jp	c,CHR_BSUB_H
	cp	12
	jp	c,CHR_BSUB_L0
	cp	20
	jp	c,CHR_BSUB_H

CHR_BSUB_L0:
	push	iy
	push	ix
	push	hl
	push	de
	push	bc
	push	af

	push	af

	srl	h
	rr	l
	ex	af,af'
	push	hl
	pop	ix
	push	hl
	pop	iy
	ld	de,8000h
	add	ix,de		; RBVRAMAhX
	ld	d,0a0h
	add	iy,de		; HGVRAMAhX

	pop	af

		; LN^p^[擪AhXZo
	ld	h,00h
	ld	l,a
	ld	b,h
	ld	c,l
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,bc		; x5
	ld	b,h
	ld	c,l
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,bc		; x25
	add	hl,hl		; x50
	add	hl,hl		; x100
	ld	bc,3000h
	add	hl,bc
	push	hl
	exx
	pop	bc
	exx

CHR_BSUB_DAT_B:
	ld	de,0000h	; wiFiDregFRBAEregFHGj
CHR_BSUB_DAT_F:
	ld	hl,0000h	; LFiHregFRBALregFHGj

	ex	af,af'
	ld	a,20		; c[v
	jr	c,CHR_BSUB_L2	; ȂWv

CHR_BSUB_L1:
	push	af

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+0),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(iy+0),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+1),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(iy+1),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	and	0f0h
	ld	c,a
	ld	a,(ix+2)
	and	0fh
	or	c
	ld	(ix+2),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	and	0f0h
	ld	c,a
	ld	a,(iy+2)
	and	0fh
	or	c
	ld	(iy+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	exx
	inc	bc
	inc	bc
	exx

	pop	af
	dec	a
	jp	nz,CHR_BSUB_L1

	jr	CHR_BSUB_L3

CHR_BSUB_L2:
	exx
	inc	bc
	inc	bc
	exx

CHR_BSUB_L21:
	push	af

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	and	0fh
	ld	c,a
	ld	a,(ix+0)
	and	0f0h
	or	c
	ld	(ix+0),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	and	0fh
	ld	c,a
	ld	a,(iy+0)
	and	0f0h
	or	c
	ld	(iy+0),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+1),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(iy+1),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+2),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(iy+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	exx
	inc	bc
	inc	bc
	exx

	pop	af
	dec	a
	jp	nz,CHR_BSUB_L21

CHR_BSUB_L3:

	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ix
	pop	iy

	ret

;
; 10x20 p^[`Tuiŗpf[^쐬j
;
; i[p^[ihbgL"11"Ahbg"00"j
; 0`9Ƃ
; 0123 / 4566 / 8901 / 2345 / 6789
;
;
; ŗpf[^i120oCg128oCgɁj
; RB00-0/HG00-0/RB00-1/HG00-1/RB00-2/HG00-2
; RB01-0/HG01-0/RB01-1/HG01-1/RB01-2/HG01-2
;   :
; RB19-0/HG19-0/RB19-1/HG19-1/RB19-2/HG19-2
; 󂫁~WoCg
;
; i[ꏊF0xE600h`0xF5FF
; LN^ԍ
; 01,02,03,04,05,06
; 12,13,14,15,16,17,18,19
; 22,23
;
CHR_BSUB_HDAT:
	push	ix
	push	hl
	push	de
	push	bc
	push	af

	ld	ix,0e600h

		; LN^p^[擪AhXZo
	exx
	ld	de,3000h + 100
	exx


CHR_BSUB_HDAT_DAT_B:
	ld	de,0000h	; wiFiDregFRBAEregFHGj
CHR_BSUB_HDAT_DAT_F:
	ld	hl,0000h	; LFiHregFRBALregFHGj

	ld	a,1
CHR_BSUB_HDAT_L3:
	push	af

	exx
	push	de
	exx

	ld	a,20		; c[v

CHR_BSUB_HDAT_L1:
	push	af

	exx
	ld	a,(de)		; Crb
	inc	de
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+0),a
	inc	ix

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(ix+0),a
	inc	ix

	exx
	ld	a,(de)		; Crb
	inc	de
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+0),a
	inc	ix

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(ix+0),a
	inc	ix

	exx
	ld	a,(de)		; Crb
	inc	de
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	and	0f0h
	ld	(ix+0),a
	inc	ix

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	and	0f0h
	ld	(ix+0),a
	inc	ix

	exx
	inc	de
	inc	de
	exx

	pop	af
	dec	a
	jp	nz,CHR_BSUB_HDAT_L1

	ld	bc,8
	add	ix,bc

	exx
	pop	de
	inc	de
	inc	de
	exx

	ld	a,20		; c[v

CHR_BSUB_HDAT_L2:
	push	af

	exx
	ld	a,(de)		; Crb
	inc	de
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	and	0fh
	ld	(ix+0),a
	inc	ix

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	and	0fh
	ld	(ix+0),a
	inc	ix

	exx
	ld	a,(de)		; Crb
	inc	de
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+0),a
	inc	ix

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(ix+0),a
	inc	ix

	exx
	ld	a,(de)		; Crb
	inc	de
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+0),a
	inc	ix

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(ix+0),a
	inc	ix

	exx
	inc	de
	inc	de
	exx

	pop	af
	dec	a
	jp	nz,CHR_BSUB_HDAT_L2

	ld	bc,8
	add	ix,bc

	exx
	dec	de
	dec	de
	exx

	pop	af
	inc	a
	cp	7
	jr	nz,CHR_BSUB_HDAT_L31
	ld	a,12

	exx
	ld	hl,500
	add	hl,de
	ex	de,hl
	exx
	jp	CHR_BSUB_HDAT_L3

CHR_BSUB_HDAT_L31;
	cp	20
	jr	nz,CHR_BSUB_HDAT_L32
	ld	a,22

	exx
	ld	hl,200
	add	hl,de
	ex	de,hl
	exx
	jp	CHR_BSUB_HDAT_L3

CHR_BSUB_HDAT_L32;
	cp	24
	jp	nz,CHR_BSUB_HDAT_L3

	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ix

	ret


;
; 10x20 p^[`TuiŃu[j
;
; a	; BLUE ̃LN^ԍ
; hl	; `VRAM擪AhX
;
; ŗpf[^i120oCg128oCgɁj
; RB00-0/HG00-0/RB00-1/HG00-1/RB00-2/HG00-2
; RB01-0/HG01-0/RB01-1/HG01-1/RB01-2/HG01-2
;   :
; RB19-0/HG19-0/RB19-1/HG19-1/RB19-2/HG19-2
; 󂫁~WoCg
;
; i[ꏊF0xE600h`
; LN^ԍ
; 01,02,03,04,05,06
; 12,13,14,15,16,17,18,19
; 22,23
;
CHR_BSUB_H:
	push	hl
	push	de
	push	bc
	push	af

	push	af

	srl	h
	rr	l
	ex	af,af'
	ld	de,8000h
	add	hl,de
	ld	b,h
	ld	c,l		; RBVRAMAhX
	ld	d,020h
	add	hl,de
	ex	de,hl		; HGVRAMAhX

	pop	af

		; LN^p^[擪AhXZo
		; 6x20x2 = 240oCg256oCg
		;
	cp	7
	jr	c,CHR_BSUB_H_L00
	sub	5
CHR_BSUB_H_L00:
	cp	20
	jr	c,CHR_BSUB_H_L01
	sub	2
CHR_BSUB_H_L01:
	ld	hl,0e500h	; LN^擪=E600H
	add	a,h
	ld	h,a

	ex	af,af'
	ld	a,20		; c[v
	jr	c,CHR_BSUB_H_L21; ȂWv

CHR_BSUB_H_L1:
	push	af

	ld	a,(hl)
	inc	hl
	ld	(bc),a
	inc	bc
	ld	a,(hl)
	inc	hl
	ld	(de),a
	inc	de

	ld	a,(hl)
	inc	hl
	ld	(bc),a
	inc	bc
	ld	a,(hl)
	inc	hl
	ld	(de),a
	inc	de

	ld	a,(bc)
	and	0fh
	or	(hl)
	inc	hl
	ld	(bc),a
	ld	a,(de)
	and	0fh
	or	(hl)
	inc	hl
	ld	(de),a

	push	hl
	ld	hl,38
	add	hl,de
	ex	de,hl
	ld	hl,38
	add	hl,bc
	ld	b,h
	ld	c,l
	pop	hl

	pop	af
	dec	a
	jp	nz,CHR_BSUB_H_L1

	jr	CHR_BSUB_H_L3

CHR_BSUB_H_L21:
	ld	l,80h

CHR_BSUB_H_L2:
	push	af

	ld	a,(bc)
	and	0f0h
	or	(hl)
	inc	hl
	ld	(bc),a
	inc	bc
	ld	a,(de)
	and	0f0h
	or	(hl)
	inc	hl
	ld	(de),a
	inc	de

	ld	a,(hl)
	inc	hl
	ld	(bc),a
	inc	bc
	ld	a,(hl)
	inc	hl
	ld	(de),a
	inc	de

	ld	a,(hl)
	inc	hl
	ld	(bc),a
	ld	a,(hl)
	inc	hl
	ld	(de),a

	push	hl
	ld	hl,38
	add	hl,de
	ex	de,hl
	ld	hl,38
	add	hl,bc
	ld	b,h
	ld	c,l
	pop	hl

	pop	af
	dec	a
	jp	nz,CHR_BSUB_H_L2

CHR_BSUB_H_L3:

	pop	af
	pop	bc
	pop	de
	pop	hl

	ret

;
; 10x20 p^[`Tuiu[]j
;
; a	; BLUE ̃LN^ԍ
; hl	; `VRAM擪AhX
;
; i[p^[ihbgL"11"Ahbg"00"j
; 0`9Ƃ
; 0123 / 4566 / 8901 / 2345 / 6789
;
CHR_BINVSUB:
	push	iy
	push	ix
	push	hl
	push	de
	push	bc
	push	af

	push	af

	srl	h
	rr	l
	ex	af,af'
	push	hl
	pop	ix
	push	hl
	pop	iy
	ld	de,8000h
	add	ix,de		; RBVRAMAhX
	ld	d,0a0h
	add	iy,de		; HGVRAMAhX

	pop	af
	and	7fh

		; LN^p^[擪AhXZo
	ld	h,00h
	ld	l,a
	ld	b,h
	ld	c,l
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,bc		; x5
	ld	b,h
	ld	c,l
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,bc		; x25
	add	hl,hl		; x50
	add	hl,hl		; x100
	ld	bc,3000h
	add	hl,bc
	push	hl
	exx
	pop	bc
	exx

CHR_BINVSUB_DAT_B:
	ld	de,0000h	; wiFiDregFRBAEregFHGj
CHR_BINVSUB_DAT_F:
	ld	hl,0000h	; LFiHregFRBALregFHGj

	ex	af,af'
	ld	a,20		; c[v
	jr	c,CHR_BINVSUB_L2; ȂWv

CHR_BINVSUB_L1:
	push	af

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	cpl
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+0),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(iy+0),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	cpl
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+1),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(iy+1),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	cpl
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	and	0f0h
	ld	c,a
	ld	a,(ix+2)
	and	0fh
	or	c
	ld	(ix+2),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	and	0f0h
	ld	c,a
	ld	a,(iy+2)
	and	0fh
	or	c
	ld	(iy+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	exx
	inc	bc
	inc	bc
	exx

	pop	af
	dec	a
	jp	nz,CHR_BINVSUB_L1

	jr	CHR_BINVSUB_L3

CHR_BINVSUB_L2:
	exx
	inc	bc
	inc	bc
	exx

CHR_BINVSUB_L21:
	push	af

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	cpl
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	and	0fh
	ld	c,a
	ld	a,(ix+0)
	and	0f0h
	or	c
	ld	(ix+0),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	and	0fh
	ld	c,a
	ld	a,(iy+0)
	and	0f0h
	or	c
	ld	(iy+0),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	cpl
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+1),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(iy+1),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	cpl
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	ld	(ix+2),a

	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	ld	(iy+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	exx
	inc	bc
	inc	bc
	exx

	pop	af
	dec	a
	jp	nz,CHR_BINVSUB_L21

CHR_BINVSUB_L3:

	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ix
	pop	iy

	ret

;
; 10x20 p^[`TuiO[{bhj
;
; a	; GREEN/RED ̃LN^ԍ
; hl	; `VRAM擪AhX
;
; GREEN/REDi[p^[
; 0`9Ƃ
; 0123:HG / 0123:RB / 4567:HG / 4567:RB / 8901:HG
; 8901:RB / 2345:HG / 2345:RB / 6789:HG / 6789:RB
;
; H ɂ́A}XNp^[i[
;
CHR_GRSUB:
	push	iy
	push	ix
	push	hl
	push	de
	push	bc
	push	af

	push	af

		; VRAMAhXZo
	srl	h
	rr	l
	ex	af,af'
	push	hl
	pop	ix
	push	hl
	pop	iy
	ld	de,8000h
	add	ix,de		; RBVRAMAhX
	ld	d,0a0h
	add	iy,de		; HGVRAMAhX

	pop	af

		; LN^p^[擪AhXZo
	ld	h,00h
	ld	l,a
	ld	b,h
	ld	c,l
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,bc		; x5
	ld	b,h
	ld	c,l
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,bc		; x25
	add	hl,hl		; x50
	add	hl,hl		; x100
	add	hl,hl		; x200
	ld	bc,4000h
	add	hl,bc

CHR_GRSUB_DAT_B:
	ld	de,0000h	; wiFiDregFRBAEregFHGj

	ex	af,af'
	ld	a,20		; c[v
	jr	c,CHR_GRSUB_L2	; ȂWv

CHR_GRSUB_L1:
	push	af

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	or	0aah
	ld	(iy+0),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	ld	(ix+0),a

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	or	0aah
	ld	(iy+1),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	ld	(ix+1),a

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	or	0aah
	and	0f0h
	ld	c,a
	ld	a,(iy+2)
	and	0fh
	or	c
	ld	(iy+2),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	and	0f0h
	ld	c,a
	ld	a,(ix+2)
	and	0fh
	or	c
	ld	(ix+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	ld	bc,4
	add	hl,bc

	pop	af
	dec	a
	jp	nz,CHR_GRSUB_L1

	jr	CHR_GRSUB_L3

CHR_GRSUB_L2:

	ld	bc,4
	add	hl,bc

CHR_GRSUB_L21:
	push	af

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	or	0aah
	and	0fh
	ld	c,a
	ld	a,(iy+0)
	and	0f0h
	or	c
	ld	(iy+0),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	and	0fh
	ld	c,a
	ld	a,(ix+0)
	and	0f0h
	or	c
	ld	(ix+0),a

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	or	0aah
	ld	(iy+1),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	ld	(ix+1),a

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	or	0aah
	ld	(iy+2),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	ld	(ix+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	ld	bc,4
	add	hl,bc

	pop	af
	dec	a
	jp	nz,CHR_GRSUB_L21

CHR_GRSUB_L3:

	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ix
	pop	iy

	ret

;
; 10x20 p^[`TuiO[{bh]j
;
; a	; GREEN/RED ̃LN^ԍ
; hl	; `VRAM擪AhX
;
; GREEN/REDi[p^[
; 0`9Ƃ
; 0123:HG / 0123:RB / 4567:HG / 4567:RB / 8901:HG
; 8901:RB / 2345:HG / 2345:RB / 6789:HG / 6789:RB
;
; H ɂ́A}XNp^[i[
;
CHR_GRINVSUB:
	push	iy
	push	ix
	push	hl
	push	de
	push	bc
	push	af

	push	af

		; VRAMAhXZo
	srl	h
	rr	l
	ex	af,af'
	push	hl
	pop	ix
	push	hl
	pop	iy
	ld	de,8000h
	add	ix,de		; RBVRAMAhX
	ld	d,0a0h
	add	iy,de		; HGVRAMAhX

	pop	af
	and	7fh

		; LN^p^[擪AhXZo
	ld	h,00h
	ld	l,a
	ld	b,h
	ld	c,l
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,bc		; x5
	ld	b,h
	ld	c,l
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,bc		; x25
	add	hl,hl		; x50
	add	hl,hl		; x100
	add	hl,hl		; x200
	ld	bc,4000h
	add	hl,bc

CHR_GRINVSUB_DAT_B:
	ld	de,0000h	; wiFiDregFRBAEregFHGj

	ex	af,af'
	ld	a,20		; c[v
	jr	c,CHR_GRINVSUB_L2	; ȂWv

CHR_GRINVSUB_L1:
	push	af

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	cpl
	or	0aah
	ld	(iy+0),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	cpl
	ld	(ix+0),a

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	cpl
	or	0aah
	ld	(iy+1),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	cpl
	ld	(ix+1),a

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	cpl
	or	0aah
	and	0f0h
	ld	c,a
	ld	a,(iy+2)
	and	0fh
	or	c
	ld	(iy+2),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	cpl
	and	0f0h
	ld	c,a
	ld	a,(ix+2)
	and	0fh
	or	c
	ld	(ix+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	ld	bc,4
	add	hl,bc

	pop	af
	dec	a
	jp	nz,CHR_GRINVSUB_L1

	jr	CHR_GRINVSUB_L3

CHR_GRINVSUB_L2:

	ld	bc,4
	add	hl,bc

CHR_GRINVSUB_L21:
	push	af

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	cpl
	or	0aah
	and	0fh
	ld	c,a
	ld	a,(iy+0)
	and	0f0h
	or	c
	ld	(iy+0),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	cpl
	and	0fh
	ld	c,a
	ld	a,(ix+0)
	and	0f0h
	or	c
	ld	(ix+0),a

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	cpl
	or	0aah
	ld	(iy+1),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	cpl
	ld	(ix+1),a

	ld	a,(hl)		; Chg
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	and	e		; wiF
	or	(hl)
	inc	hl
	cpl
	or	0aah
	ld	(iy+2),a

	ld	a,b
	and	d		; wiF
	or	(hl)		; Crb
	inc	hl
	cpl
	ld	(ix+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	ld	bc,4
	add	hl,bc

	pop	af
	dec	a
	jp	nz,CHR_GRINVSUB_L21

CHR_GRINVSUB_L3:

	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ix
	pop	iy

	ret


;
; 10x20 p^[`Tuiu[{O[{bhj
;
; a	; GREEN/RED ̃LN^ԍ
; e	; BLUE ̃LN^ԍ
; hl	; `VRAM擪AhX
;
;
; GREEN/REDi[p^[
; 0`9Ƃ
; 0123:HG / 0123:RB / 4567:HG / 4567:RB / 8901:HG
; 8901:RB / 2345:HG / 2345:RB / 6789:HG / 6789:RB
;
; H ɂ́A}XNp^[i[
;
CHR_BGR_SUB:
	push	iy
	push	ix
	push	hl
	push	de
	push	bc
	push	af

	ld	d,a
	push	de

		; VRAMAhXZo
	srl	h
	rr	l
	ex	af,af'
	push	hl
	pop	ix
	push	hl
	pop	iy
	ld	de,8000h
	add	ix,de		; RBVRAMAhX
	ld	d,0a0h
	add	iy,de		; HGVRAMAhX

	pop	de
	res	7,d
	res	7,e

		; LN^p^[擪AhXZo(BULE)
	ld	h,00h
	ld	l,e
	ld	b,h
	ld	c,l
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,bc		; x5
	ld	b,h
	ld	c,l
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,bc		; x25
	add	hl,hl		; x50
	add	hl,hl		; x100
	ld	bc,3000h
	add	hl,bc
	push	hl
	exx
	pop	bc
	exx

		; LN^p^[擪AhXZo(GREEN/RED)
	ld	h,00h
	ld	l,d
	ld	b,h
	ld	c,l
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,bc		; x5
	ld	b,h
	ld	c,l
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,bc		; x25
	add	hl,hl		; x50
	add	hl,hl		; x100
	add	hl,hl		; x200
	ld	bc,4000h
	add	hl,bc
	push	hl
	exx
	pop	hl
	exx

CHR_BGRSUB_DAT_B:
	ld	de,0000h	; wiFiDregFRBAEregFHGj
CHR_BGRSUB_DAT_F:
	ld	hl,0000h	; LFiHregFRBALregFHGj

	ex	af,af'
	ld	a,20		; c[v
	jp	c,CHR_BGRSUB_L2	; ȂWv

CHR_BGRSUB_L1:
	push	af

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	or	0aah
	ld	(iy+0),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	ld	(ix+0),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	or	0aah
	ld	(iy+1),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	ld	(ix+1),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	or	0aah
	and	0f0h
	ld	c,a
	ld	a,(iy+2)
	and	0fh
	or	c
	ld	(iy+2),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	and	0f0h
	ld	c,a
	ld	a,(ix+2)
	and	0fh
	or	c
	ld	(ix+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	exx
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	bc
	inc	bc
	exx

	pop	af
	dec	a
	jp	nz,CHR_BGRSUB_L1

	jp	CHR_BGRSUB_L3

CHR_BGRSUB_L2:

	exx
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	bc
	inc	bc
	exx

CHR_BGRSUB_L21:
	push	af

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	or	0aah
	and	0fh
	ld	c,a
	ld	a,(iy+0)
	and	0f0h
	or	c
	ld	(iy+0),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	and	0fh
	ld	c,a
	ld	a,(ix+0)
	and	0f0h
	or	c
	ld	(ix+0),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	or	0aah
	ld	(iy+1),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	ld	(ix+1),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	or	0aah
	ld	(iy+2),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	ld	(ix+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	exx
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	bc
	inc	bc
	exx

	pop	af
	dec	a
	jp	nz,CHR_BGRSUB_L21

CHR_BGRSUB_L3:

	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ix
	pop	iy

	ret

;
; 10x20 p^[`Tuiu[{O[{bh]j
;
; a	; GREEN/RED ̃LN^ԍ
; e	; BLUE ̃LN^ԍ
; hl	; `VRAM擪AhX
;
;
; GREEN/REDi[p^[
; 0`9Ƃ
; 0123:HG / 0123:RB / 4567:HG / 4567:RB / 8901:HG
; 8901:RB / 2345:HG / 2345:RB / 6789:HG / 6789:RB
;
; H ɂ́A}XNp^[i[
;
CHR_BGRINV_SUB:
	push	iy
	push	ix
	push	hl
	push	de
	push	bc
	push	af

	ld	d,a
	push	de

		; VRAMAhXZo
	srl	h
	rr	l
	ex	af,af'
	push	hl
	pop	ix
	push	hl
	pop	iy
	ld	de,8000h
	add	ix,de		; RBVRAMAhX
	ld	d,0a0h
	add	iy,de		; HGVRAMAhX

	pop	de
	res	7,d
	res	7,e

		; LN^p^[擪AhXZo(BULE)
	ld	h,00h
	ld	l,e
	ld	b,h
	ld	c,l
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,bc		; x5
	ld	b,h
	ld	c,l
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,bc		; x25
	add	hl,hl		; x50
	add	hl,hl		; x100
	ld	bc,3000h
	add	hl,bc
	push	hl
	exx
	pop	bc
	exx

		; LN^p^[擪AhXZo(GREEN/RED)
	ld	h,00h
	ld	l,d
	ld	b,h
	ld	c,l
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,bc		; x5
	ld	b,h
	ld	c,l
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,bc		; x25
	add	hl,hl		; x50
	add	hl,hl		; x100
	add	hl,hl		; x200
	ld	bc,4000h
	add	hl,bc
	push	hl
	exx
	pop	hl
	exx

CHR_BGRINVSUB_DAT_B:
	ld	de,0000h	; wiFiDregFRBAEregFHGj
CHR_BGRINVSUB_DAT_F:
	ld	hl,0000h	; LFiHregFRBALregFHGj

	ex	af,af'
	ld	a,20		; c[v
	jp	c,CHR_BGRINVSUB_L2	; ȂWv

CHR_BGRINVSUB_L1:
	push	af

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	cpl
	or	0aah
	ld	(iy+0),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	cpl
	ld	(ix+0),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	cpl
	or	0aah
	ld	(iy+1),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	cpl
	ld	(ix+1),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	cpl
	or	0aah
	and	0f0h
	ld	c,a
	ld	a,(iy+2)
	and	0fh
	or	c
	ld	(iy+2),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	cpl
	and	0f0h
	ld	c,a
	ld	a,(ix+2)
	and	0fh
	or	c
	ld	(ix+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	exx
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	bc
	inc	bc
	exx

	pop	af
	dec	a
	jp	nz,CHR_BGRINVSUB_L1

	jp	CHR_BGRINVSUB_L3

CHR_BGRINVSUB_L2:

	exx
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	bc
	inc	bc
	exx

CHR_BGRINVSUB_L21:
	push	af

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	cpl
	or	0aah
	and	0fh
	ld	c,a
	ld	a,(iy+0)
	and	0f0h
	or	c
	ld	(iy+0),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	cpl
	and	0fh
	ld	c,a
	ld	a,(ix+0)
	and	0f0h
	or	c
	ld	(ix+0),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	cpl
	or	0aah
	ld	(iy+1),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	cpl
	ld	(ix+1),a

	exx
	ld	a,(bc)		; Crb
	inc	bc
	exx
	ld	b,a
	and	h
	ld	c,a		; LF
	ld	a,b
	cpl
	and	d		; wiF
	or	c
	exx
	ld	d,a		; u[{wiiRB)
	exx
	ld	a,b
	and	l
	ld	c,a		; LF
	ld	a,b
	cpl
	and	e		; wiF
	or	c
	exx
	ld	e,a		; u[{wiiHG)
	ld	a,(hl)		; Chg
	exx
	and	0aah
	ld	b,a
	rrca
	or	b
	ld	b,a		; wip^[
	exx
	and	e		; u[{wi(HG)
	or	(hl)
	inc	hl
	exx
	cpl
	or	0aah
	ld	(iy+2),a
	ld	a,b
	exx
	and	d		; u[{wi(RB)
	or	(hl)		; Crb
	inc	hl
	exx
	cpl
	ld	(ix+2),a

	ld	bc,40
	add	ix,bc
	add	iy,bc

	exx
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	bc
	inc	bc
	exx

	pop	af
	dec	a
	jp	nz,CHR_BGRINVSUB_L21

CHR_BGRINVSUB_L3:

	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ix
	pop	iy

	ret


	org	07fffh
	db	0ffh

	end
